'
'       NML2 (No More Life 2) v1.0
'
'       Copyright(C) 2002 by ICC Software
'
'       Republished in 2009 by Paul Wilhelm <paul@mosfetkiller.de>
'       http://mosfetkiller.de/
'
'       --- HAUPTMEN ---
'
DECLARE SUB ckb ()
DECLARE SUB story ()
DECLARE SUB game ()
DECLARE SUB waitkey ()
DECLARE SUB instructions ()
DECLARE SUB mainmenu ()
DECLARE SUB pload (pi$)
DECLARE SUB font (x!, y!, t$)
DECLARE SUB clearscreen (r!)
DECLARE SUB delay (L!, keystop!)
DECLARE SUB palload (filename$)
DECLARE SUB center (y!, t$)
DIM SHARED path$, bombe%(1000)

'Wenn das Programm die Dateien nicht finden kann,
'hier den Pfad eintragen (mit abschliessendem Backslash)
path$ = ""

SCREEN 12
CLS
ckb
LINE (14, 10)-(26, 17), 7, B
LINE (15, 11)-(25, 17), 8, BF
CIRCLE (20, 36), 20, 7
PAINT (20, 36), 8, 7
LINE (20, 9)-(17, 0), 14
LINE (21, 9)-(18, 0), 14
LINE (19, 9)-(16, 0), 14
GET (0, 0)-(40, 56), bombe%
CLS
ckb
mainmenu
ckb
SYSTEM

SUB center (y, t$)

'Eine SUB, die einen Text in der Schriftart Psycho
'in die Bildschirmmitte zeichnet.
'Die einzelnen Buchstaben habe ich in Microsoft Paint (Igitt !) gemalt,
'und dann mit einem selbstgeschriebenen Programm als BSAVE-Bilder gespeichert.

x = 320 - 18 * LEN(t$) / 2 - 18
FOR a = 1 TO LEN(t$)
a$ = MID$(t$, a, 1)
SELECT CASE UCASE$(a$)
CASE "": a$ = "ae"
CASE "": a$ = "oe"
CASE "": a$ = "ue"
CASE " ": a$ = "space"
CASE CHR$(34): a$ = "anf"
CASE "@": a$ = "at"
CASE "!": a$ = "ausrufe"
CASE "\": a$ = "bckslash"
CASE "$": a$ = "dollar"
CASE ":": a$ = "doppel"
CASE "?": a$ = "frage"
CASE "=": a$ = "gleich"
CASE ">": a$ = "gross"
CASE "'": a$ = "hochkomm"
CASE ")": a$ = "klauf"
CASE "(": a$ = "klzu"
CASE ",": a$ = "komma"
CASE "-": a$ = "minus"
CASE "#": a$ = "nummer"
CASE "+": a$ = "plus"
CASE "%": a$ = "prozent"
CASE ".": a$ = "punkt"
CASE ";": a$ = "semiko"
CASE "/": a$ = "slash"
CASE "*": a$ = "stern"
CASE "": a$ = "sz"
CASE "&": a$ = "und"
CASE "_": a$ = "unterst"
CASE "~": a$ = "welle"
CASE "": a$ = "up"
CASE "": a$ = "left"
CASE CHR$(26): a$ = "right"
CASE ELSE: a$ = UCASE$(a$)
END SELECT
OPEN path$ + "charset\" + a$ + ".chr" FOR BINARY AS #255
IF LOF(255) = 0 THEN CLOSE : KILL path$ + a$ + ".chr": a$ = "space"
CLOSE #255
REDIM F%(1 TO 2000)
DEF SEG = VARSEG(F%(1))
BLOAD path$ + "charset\" + a$ + ".chr", VARPTR(F%(1))
DEF SEG
xx = x + 18 * a
PUT (xx, y), F%, OR
NEXT a
END SUB

SUB ckb

'Verhindert ein berlaufen des Keyboard-Buffers und das damit verbundene Piepen.

FOR a = 1 TO 15
key$ = INKEY$
NEXT a
END SUB

SUB clearscreen (r)

'Lscht den Bildschirm mal etwas anders als CLS.

FOR fx = 0 TO 300 STEP 15
FOR fy = 0 TO 479 STEP 15
LINE (fx, fy)-(fx + 15, fy + 15), r
LINE (639 - fx, fy)-(639 - fx - 15, fy + 15), r
NEXT fy
SOUND 0, .1
NEXT fx
FOR fx = 320 TO 0 STEP -15
FOR fy = 479 TO 0 STEP -15
LINE (fx, fy)-(fx - 15, fy - 15), 0, BF
LINE (639 - fx, fy)-(639 - fx - 15, fy - 15), 0, BF
NEXT fy
SOUND 0, .1
NEXT fx
CLS
PALETTE
COLOR 7
END SUB

SUB delay (L!, keystop!)

'Wartet minimal 0,002 Sekunden.
'Ausserdem kann man, wenn keystop! = 1 ist, die Schleife beenden,
'diese SUB ist also quasi ein SLEEP-Befehl mit genaueren Wartezeiten.
'Ausserdem Piept es, wenn man den SLEEP-Befehl ber 15 Mal im Programm
'eingebaut hat. Hier ist das nicht der Fall.

ckb
s! = TIMER
start! = INP(&H60)
DO
IF keystop! = 1 AND NOT INP(&H60) = start! THEN EXIT DO
LOOP UNTIL TIMER - s! >= L!
END SUB

SUB font (x, y, t$)

'Eine SUB, die einen Text in der Schriftart Psycho
'an die Position X, Y zeichnet.
'Die einzelnen Buchstaben habe ich in Microsoft Paint (Igitt !) gemalt,
'und dann mit einem selbstgeschriebenen Programm als BSAVE-Bilder gespeichert.

FOR a = 1 TO LEN(t$)
a$ = MID$(t$, a, 1)
SELECT CASE UCASE$(a$)
CASE " ": a$ = "space"
CASE CHR$(34): a$ = "anf"
CASE "@": a$ = "at"
CASE "!": a$ = "ausrufe"
CASE "\": a$ = "bckslash"
CASE "$": a$ = "dollar"
CASE ":": a$ = "doppel"
CASE "?": a$ = "frage"
CASE "=": a$ = "gleich"
CASE ">": a$ = "gro"
CASE "'": a$ = "hochkomm"
CASE ")": a$ = "klauf"
CASE "(": a$ = "klzu"
CASE ",": a$ = "komma"
CASE "-": a$ = "minus"
CASE "#": a$ = "nummer"
CASE "+": a$ = "plus"
CASE "%": a$ = "prozent"
CASE ".": a$ = "punkt"
CASE ";": a$ = "semiko"
CASE "/": a$ = "slash"
CASE "*": a$ = "stern"
CASE "": a$ = "sz"
CASE "&": a$ = "und"
CASE "_": a$ = "unterst"
CASE "~": a$ = "welle"
CASE "": a$ = "up"
CASE CHR$(25): a$ = "down"
CASE "": a$ = "left"
CASE CHR$(26): a$ = "right"
CASE "", "": a$ = "ae"
CASE "", "": a$ = "oe"
CASE "", "": a$ = "ue"
CASE ELSE: a$ = UCASE$(a$)
END SELECT
OPEN path$ + "charset\" + a$ + ".chr" FOR BINARY AS #255
IF LOF(255) = 0 THEN CLOSE : KILL path$ + a$ + ".chr": a$ = "space"
CLOSE #255
REDIM F%(1 TO 2000)
DEF SEG = VARSEG(F%(1))
BLOAD path$ + "charset\" + a$ + ".chr", VARPTR(F%(1))
DEF SEG
xx = x + 18 * a
IF xx > 619 THEN x = -18 * a: xx = 0: y = y + 20
PUT (xx, y), F%, OR
NEXT a
END SUB

SUB game

'Startet das eigentliche Spiel.

SCREEN 0
CHAIN "GAME.BAS"

END SUB

SUB instructions

'Zeigt Informationen ber die Steuerung des Spieles an.

SCREEN 12
CLS
LINE (0, 0)-(639, 479), 11, B
LINE (1, 1)-(638, 478), 3, B
LINE (2, 2)-(637, 477), 9, B
LINE (3, 3)-(636, 476), 1, B
LINE (230 - 15, 30)-(410 + 15, 70), 7, BF
LINE (411 + 15, 40)-(420 + 15, 80), 8, BF
LINE (240 - 15, 71)-(410 + 15, 80), 8, BF
center 40, "steuerung 1"
py = 0
LINE (10, 140 + py)-(40, 170 + py), 7, BF
LINE (41, 145 + py)-(45, 175 + py), 8, BF
LINE (15, 171 + py)-(45, 175 + py), 8, BF
font 0, 145 + py, "" + " ........................Springen"
LINE (10, 190 + py)-(40, 220 + py), 7, BF
LINE (41, 195 + py)-(45, 225 + py), 8, BF
LINE (15, 221 + py)-(45, 225 + py), 8, BF
font 0, 195 + py, "" + " ......................Nach links"
LINE (10, 240 + py)-(40, 270 + py), 7, BF
LINE (41, 245 + py)-(45, 275 + py), 8, BF
LINE (15, 271 + py)-(45, 275 + py), 8, BF
font 0, 245 + py, CHR$(26) + " .....................Nach rechts"
py = py - 50
LINE (10, 340 + py)-(40, 370 + py), 7, BF
LINE (41, 345 + py)-(45, 375 + py), 8, BF
LINE (15, 371 + py)-(45, 375 + py), 8, BF
font 0, 345 + py, CHR$(25) + " .....................sich ducken"
py = py + 100
LINE (10, 290 + py)-(130, 320 + py), 7, BF
LINE (131, 295 + py)-(135, 325 + py), 8, BF
LINE (15, 321 + py)-(135, 325 + py), 8, BF
font 5, 295 + py, "SPACE ...................Schiessen"
py = py + 50
LINE (10, 290 + py)-(130, 320 + py), 7, BF
LINE (131, 295 + py)-(135, 325 + py), 8, BF
LINE (15, 321 + py)-(135, 325 + py), 8, BF
font 5, 295 + py, " ESC  ...............spiel beenden"

waitkey

CLS
LINE (0, 0)-(639, 479), 11, B
LINE (1, 1)-(638, 478), 3, B
LINE (2, 2)-(637, 477), 9, B
LINE (3, 3)-(636, 476), 1, B
LINE (230 - 15, 30)-(410 + 15, 70), 7, BF
LINE (411 + 15, 40)-(420 + 15, 80), 8, BF
LINE (240 - 15, 71)-(410 + 15, 80), 8, BF
center 40, "steuerung 2"
py = -22
LINE (10, 140 + py)-(40, 170 + py), 7, BF
LINE (41, 145 + py)-(45, 175 + py), 8, BF
LINE (15, 171 + py)-(45, 175 + py), 8, BF
font 0, 145 + py, "C ..................Cheat eingeben"
LINE (10, 190 + py)-(40, 220 + py), 7, BF
LINE (41, 195 + py)-(45, 225 + py), 8, BF
LINE (15, 221 + py)-(45, 225 + py), 8, BF
font 0, 195 + py, "S ...................Stromschocker"
LINE (10, 240 + py)-(40, 270 + py), 7, BF
LINE (41, 245 + py)-(45, 275 + py), 8, BF
LINE (15, 271 + py)-(45, 275 + py), 8, BF
font 0, 245 + py, "P ...........................Pause"
py = py - 50
LINE (10, 340 + py)-(40, 370 + py), 7, BF
LINE (41, 345 + py)-(45, 375 + py), 8, BF
LINE (15, 371 + py)-(45, 375 + py), 8, BF
font 0, 345 + py, "L ...................Ton ein / aus"
py = py + 100
LINE (10, 290 + py)-(130, 320 + py), 7, BF
LINE (131, 295 + py)-(135, 325 + py), 8, BF
LINE (15, 321 + py)-(135, 325 + py), 8, BF
font 5, 295 + py, "1 - 9 .........Schimpfwrter sagen"
py = py + 50
LINE (10, 290 + py)-(130, 320 + py), 7, BF
LINE (131, 295 + py)-(135, 325 + py), 8, BF
LINE (15, 321 + py)-(135, 325 + py), 8, BF
font 5, 295 + py, "F1, F2 ....Spiel laden / speichern"
LINE (10, 340 + py)-(40, 370 + py), 7, BF
LINE (41, 345 + py)-(45, 375 + py), 8, BF
LINE (15, 371 + py)-(45, 375 + py), 8, BF
font 0, 345 + py, "B ....................Bombe werfen"
waitkey

clearscreen 4
mainmenu

END SUB

SUB mainmenu

'Das Hauptmen anzeigen.

ckb
SCREEN 12
CLS
LINE (0, 0)-(639, 479), 1, B
LINE (1, 1)-(638, 478), 9, B
LINE (2, 2)-(637, 477), 3, B
LINE (3, 3)-(636, 476), 11, B

LINE (230, 30)-(410, 70), 7, BF
center 40, "Hauptmen"
LINE (411, 40)-(420, 80), 8, BF
LINE (240, 71)-(410, 80), 8, BF
PUT (185, 130), bombe%, PSET
font 180, 155, "1    Spielen"
PUT (185, 190), bombe%, PSET
font 180, 215, "2    Story"
PUT (185, 250), bombe%, PSET
font 180, 275, "3    Steuerung"
PUT (185, 310), bombe%, PSET
font 180, 335, "4    Beenden"

DO
        a$ = INKEY$
        SELECT CASE a$
        CASE CHR$(27), "4": ckb: SYSTEM
        CASE "1": clearscreen 14: ckb: game
        CASE "2": clearscreen 2: ckb: story
        CASE "3": clearscreen 1: ckb: instructions
        END SELECT
LOOP

END SUB

DEFINT A-Z
SUB palload (filename$)

'Diese SUB ldt eine 4- bzw. 8-Bit-Farbpalette.

DIM Byto AS STRING * 1
OPEN filename$ FOR BINARY AS #1
IF LOF(1) = 48 THEN an = 0: en = 15
IF LOF(1) = 768 THEN an = 0: en = 255
FOR Att% = an TO en
OUT &H3C8, Att%
FOR RedGreenAndBlue% = 1 TO 3
GET #1, , Byto
Valew% = ASC(Byto)
OUT &H3C9, Valew%
NEXT RedGreenAndBlue%
NEXT Att%
CLOSE #1
END SUB

SUB pload (pi$)

'Eine BLOAD Rountine fr SCREEN 13.

REDIM ScreenBuffer%(32000)
DEF SEG = VARSEG(ScreenBuffer%(0))
BLOAD path$ + "graphics\" + pi$ + ".pic", VARPTR(ScreenBuffer%(0))
DEF SEG : palload path$ + "graphics\" + pi$ + ".pal"
PUT (0, 0), ScreenBuffer%, PSET

END SUB

DEFSNG A-Z
SUB story

'Die Story von dir und deinem Geld.

SCREEN 13
CLS
pload "story6"
waitkey
pload "story5"
PLAY "l64c>c>c<c<c"
pload "story4"
PLAY "l64d>d>d<d<d"
pload "story3"
PLAY "l64e>e>e<e<e"
pload "story2"
PLAY "l64f>f>f<f<f"
pload "story1"
delay 1.5, 1
pload "story7"
FOR a = 1 TO 1000 STEP 10
SOUND 37 + a * SQR(a), .1
NEXT a
FOR a = 1000 TO 0 STEP -10
SOUND 37 + a * SQR(a), .1
NEXT a
waitkey
pload "story8"
waitkey
pload "story9"
waitkey
pload "story10"
waitkey
pload "story11"
waitkey
pload "story12"
waitkey
pload "story13"
waitkey
mainmenu

END SUB

SUB waitkey

'Wartet bis eine Taste gedrckt wird.
'Verhindert das von SLEEP gewohnte Piepen.

ckb
DO
LOOP WHILE INKEY$ = ""
END SUB

